Core - Bug # 66411

Status: Resolved Priority: Must have
Author: Mathias Brodala Category: Default
Created: 2015-04-14 Assigned To: Mathias Brodala
Updated: 2015-04-20 Due date:

TYPO3 Version: 7

PHP Version:

Complexity:

Is Regression: No

Sprint Focus: Stabilization Sprint

Subject: New locking API exceptions too generic

Description

The new locking API currently only uses RuntimeException to hint at errors during lock acquisition.

While this already has the disadvantage of catching other @RuntimeException@s the issue becomes rather clear with the
non-blocking example:

try {

$result = $locker->acquire(LockingStrategylnterface::LOCK_CAPABILITY_SHARED |
LockingStrategyInterface::LOCK_CAPABILITY_NOBLOCK);
catch (\RuntimeException $e) {

if ($e->getCode() === 1428700748) {

// some process owns the lock, let's do something else meanwhile

}

1

This requires knowing about this special case and knowing the magic number here. A dedicated exception would make this clearer.

Related issues:
follows Core - Feature # 47712: Refactor Locking Resolved 2013-02-08

Associated revisions

Revision 51¢1996 - 2015-04-20 23:17 - Mathias Brodala

[FOLLOWUP][TASK] Add meaningful exceptions to new locking API

This adds dedicated exceptions to the new locking API which
vastly simplifies usage workflows.

Since the new APl was not yet released, this is a non-breaking
change.

Resolves: #66411

Related: #47712

Releases: master

Change-Id: lae44eaa121562469b64222f5837f7a48e6d9fc14
Reviewed-on: http://review.typo3.0rg/38683

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

2015-08-04 1/3



http://review.typo3.org/38683
mailto:klein.t3@reelworx.at
mailto:klein.t3@reelworx.at

Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

History

#1 - 2015-04-14 09:59 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0org/38683

#2 - 2015-04-14 10:00 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38683

#3 - 2015-04-14 10:01 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38683

#4 - 2015-04-14 10:04 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0org/38683

#5 - 2015-04-14 11:09 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38683

#6 - 2015-04-15 08:43 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38683

#7 - 2015-04-15 12:50 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0org/38683

#8 - 2015-04-15 14:04 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38683
#9 - 2015-04-17 08:31 - Anja Leichsenring

- Sprint Focus set to Stabilization Sprint

#10 - 2015-04-20 23:30 - Mathias Brodala
- Status changed from Under Review to Resolved
- % Done changed from 50 to 100

Applied in changeset commit:f51¢1996679752b1b7fd3c7d54aa99f76405031f.
